#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# http://www.imagemagick.org/Usage/crop/#border
# ACHTUNG xclip muss installiert sein, damit pyperclip funktioniert.
import os.path
import os
import pathlib
import shutil

import pyperclip
import datetime
import re


def strToStandard(s):
    s = s.lower()
    s = s.replace(' ', '_')
    s = s.replace('#', '_')
    s = s.replace('*', '_')
    s = s.replace('\\', '_')
    s = s.replace('/', '_')
    s = s.replace('.', '_')
    s = s.replace('-', '_')
    s = s.replace('"', '_')
    s = s.replace(':', '_')
    s = s.replace('ä', 'ae')
    s = s.replace('ö', 'oe')
    s = s.replace('ü', 'ue')
    s = s.replace('Ä', 'Ae')
    s = s.replace('Ö', 'Oe')
    s = s.replace('Ü', 'Ue')
    s = s.replace('ß', 'ss')
    s = re.sub('[^a-zA-Z0-9,_]', '_', s)
    s = s.replace('___', '_')
    s = s.replace('__', '_')
    s = s.rstrip('_')
    return s


def strToStandardDateiname(s):
    aName, aExtension = os.path.splitext(s)
    aName = strToStandard(aName)
    return aName + aExtension


def getJJJJ():
    return datetime.datetime.today().year


def verkleinern_bild(qDateiname, zDateiname):
    # print(qDateiname)
    if os.path.isfile(qDateiname):
        t = os.path.splitext(qDateiname)[1].lower()
        # print(t)
        if (t == '.jpg') or (t == '.jpeg'):
            # Jetzt das Bild rotieren, falls möglich und nötig
            s = 'exifautotran "%s"' % qDateiname
            os.system(s)
            # print aDateiname
            s = 'convert "%s" -define jpeg:extent=100kb -resize \'800x\' -bordercolor White -border 5x5  "%s"' % (
                qDateiname, zDateiname)
            os.system(s)
            # print s


def ForceDir(aPfad):
    if not os.path.exists(aPfad):
        os.makedirs(aPfad)
    return os.path.exists(aPfad)


def getVorsilbe(aVerzeichnis):
    dirname, filename = os.path.split(aVerzeichnis)
    return strToStandard(filename)


def getZielverzeichnis(aWWW, aJahr, aVorsilbe):
    aZielverzeichnis = aWWW % aJahr
    aZielverzeichnis = os.path.join(aZielverzeichnis, aVorsilbe)
    ForceDir(aZielverzeichnis)
    return aZielverzeichnis


def getZieldateiname(aVerzeichnis, aVorsilbe, i):
    aZieldateiname = '%s_%02d.jpg' % (aVorsilbe, i)
    aZieldateiname = os.path.join(aVerzeichnis, aZieldateiname)
    return aZieldateiname


def verkleinern_einVerzeichnis(aQuellVerzeichnis):
    aQuellVerzeichnis = os.path.abspath(aQuellVerzeichnis)
    # print(aQuellVerzeichnis)
    aJahr = getJJJJ()
    aVorsilbe = getVorsilbe(aQuellVerzeichnis)
    aTempVerzeichnis = '/tmp/wnfjpeg_verzeichnis/%s/%s' % (aJahr, aVorsilbe)
    ForceDir(aTempVerzeichnis)
    # print(aTempVerzeichnis)
    y = os.listdir(aQuellVerzeichnis)
    y.sort()
    i = 0
    aClipboard = ''
    for qDateiname in y:
        if (qDateiname.lower().endswith('.jpg')) or (qDateiname.lower().endswith('.jpeg')):
            i = i + 1
            zDateiname = getZieldateiname(aTempVerzeichnis, aVorsilbe, i)
            qDateiname = os.path.join(aQuellVerzeichnis, qDateiname)
            verkleinern_bild(qDateiname, zDateiname)
            # print (zDateiname)
            aClipboard = "%s [* ../bilder/%s/%s/%s *]\n\n" % (
                aClipboard, aJahr, aVorsilbe, os.path.basename(zDateiname))
        if qDateiname.lower().endswith('.pdf'):
            zDateiname = '%s/%s' % (aTempVerzeichnis, strToStandardDateiname(qDateiname))
            shutil.copyfile(os.path.join(aQuellVerzeichnis, qDateiname), zDateiname)
            aClipboard = '%s- "%s":/sites/default/files/bilder/%s/%s/%s\n' % (
                aClipboard, os.path.basename(zDateiname), aJahr, aVorsilbe, os.path.basename(zDateiname))

    print(aClipboard)
    pyperclip.set_clipboard('klipper')
    pyperclip.copy(aClipboard)
    return aJahr, aVorsilbe, aTempVerzeichnis


def verkleinern_einBild(aQuellDatei):
    aJahr = getJJJJ()
    aTempVerzeichnis = '/tmp/wnfjpeg_verzeichnis/%s/' % aJahr
    ForceDir(aTempVerzeichnis)
    # print(aTempVerzeichnis)
    aClipboard = ''
    qDateiname = os.path.basename(aQuellDatei)
    zDateiname = os.path.join(aTempVerzeichnis, strToStandardDateiname(qDateiname))
    if (qDateiname.lower().endswith('.jpg')) or (qDateiname.lower().endswith('.jpeg')):
        verkleinern_bild(aQuellDatei, zDateiname)
        # print (zDateiname)
        aClipboard = "%s [* ../bilder/%s/%s *]\n" % (
            aClipboard, aJahr, os.path.basename(zDateiname))
    if qDateiname.lower().endswith('.pdf'):
        shutil.copyfile(aQuellDatei, zDateiname)
        aClipboard = '%s- "%s":/sites/default/files/bilder/%s/%s\n' % (
            aClipboard, os.path.basename(zDateiname), aJahr, os.path.basename(zDateiname))

    print(aClipboard)
    pyperclip.set_clipboard('klipper')
    pyperclip.copy(aClipboard)
    return aJahr, zDateiname


if __name__ == "__main__":
    print("Alle Bilder des Verzeichnisses für www bereitstellen (600 Pixel breit)")
    aDemo = '/home/wnf/Temp/demo_wnfjpeg_verzeichnis/'
    verkleinern_einVerzeichnis(aDemo)
